#include <iostream>
#include <algorithm>
#include <string>
#include <sstream>
#include <random>
#include <cstdlib>
#include <ctime>
#include <vector>

using namespace std;

struct three_elements {
public:
    double min_val;
    double max_val;
    double medium;

};

double max_of_two(double a_1, double a_2);
double max_of_three(double a_1, double a_2, double a_3);
double min_of_two(double a_1, double a_2);
double min_of_three(double a_1, double a_2, double a_3);
three_elements max_and_min_of_three(double a_1, double a_2, double a_3);
int get_number_of_digits(int num);
int gcd(int a, int b);
long long lcm(long long a, long long b);
string reverse(int num);
void dice(int lower, int bigger);
unsigned long long factorial(int number);
int calc_fib(int num);
int sum_of_dividers(int number, int divider = 1);
vector<string> friends(int number);
string int_to_string(int num);
int get_digit_sum(int number);
vector<int> changeless(int number, int lowest_mult, int biggest_mult);


int main() {
    int a_1 = 1, a_2 = 2, a_3 = 3;

    cout << "a = " << a_1 << "; b = " << a_2 << "; c = " << a_3 << endl << endl;

    // #1
    cout << "#1 \t max = " << max_of_three(a_1, a_2, a_3) << endl << endl;

    // #2
    three_elements our_three_object = max_and_min_of_three(a_1, a_2, a_3);
    cout << "#2 \t max = " << our_three_object.max_val
         << "\t min = " << our_three_object.min_val << endl << endl;

    // #3
    int num = 123456789;
    cout << "#3 \t number = " << num
         << "\t number of digits: " << get_number_of_digits(num) << endl << endl;

    // #4
    a_1 = 24; a_2 = 48;
    cout << "#4 \t " << "gcd(" << a_1 << "; " << a_2 << ") = " << gcd(a_1, a_2) << endl << endl;

    // #5
    a_1 = 6; a_2 = 8;
    cout << "#5 \t " << "lcm(" << a_1 << "; " << a_2 << ") = " << lcm(a_1, a_2) << endl << endl;

    // #6
    int my_number = 102340;
    cout << "#6 \t " << "number = " << my_number
         << "\treverse: " << reverse(my_number) << endl << endl;

    // #7
    int lower = 1, bigger = 6;
    dice(lower, bigger);

    // #8
    int number = 5;
    cout << "#8 \t " << number << "! = " << factorial(number) << endl << endl;

    // #9 fibonacci numbers: 0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, ...
    number = 10;
    cout << "#9 \t " << "F[" << number << "] = " << calc_fib(number) << endl << endl;

    // #10
    number = 1000;
    cout << "#10 \t " << "number = " << number << endl << "\t ";
    vector<string> friends_vector = friends(1000);
    for (const auto item: friends_vector)
        cout << item << "; ";

    cout << endl << endl;

    // #11
    cout << "#11 \t ";
    number = 500;
    int lowest_mult = 2, biggest_mult = 9;
    vector<int> my_vector = changeless(number, lowest_mult, biggest_mult);
    for (const auto item: my_vector)
        cout << item << ' ';

    return 0;
}

double max_of_two(double a_1, double a_2)
{
    if (a_1 > a_2)
        return a_1;
    else
        return a_2;
}

double max_of_three(double a_1, double a_2, double a_3)
{
    return max_of_two(max_of_two(a_1, a_2), a_3);
}

double min_of_two(double a_1, double a_2)
{
    if (a_1 < a_2)
        return a_1;
    else
        return a_2;
}

double min_of_three(double a_1, double a_2, double a_3)
{
    return min_of_two(min_of_two(a_1, a_2), a_3);
}

three_elements max_and_min_of_three(double a_1, double a_2, double a_3)
{
    three_elements our_elements;
    our_elements.max_val = max_of_three(a_1, a_2, a_3);
    our_elements.min_val = min_of_three(a_1, a_2, a_3);
    our_elements.medium = a_1 + a_2 + a_3 - our_elements.max_val - our_elements.min_val;

    return our_elements;
}

int get_number_of_digits(int num)
{
    int counter = 0;
    while (num > 0)
    {
        num /= 10;
        counter++;
    }
    return counter;
}

int gcd(int a, int b)
{
    if (not b)
    {
       return a;
    }
    else
    {
        return gcd(b, a % b);
    }
}

long long lcm(long long a, long long b)
{
  //cout << a * b << endl;
  //cout << gcd(a, b) << endl;
  return a * b / gcd(a, b);
}

string reverse(int num)
{
    stringstream ss;
    ss << num;
    string str = ss.str();
    reverse(str.begin(), str.end());
    return str;
}

void dice(int lower, int bigger)
{
    srand(time(0));
    int d_1 = rand() % bigger + lower;
    int d_2 = rand() % bigger + lower;
    cout << "#7 \t dice: " << d_1 << " " << d_2 << endl << endl;
}

unsigned long long factorial(int number)
{
    if (number == 1)
    {
        return 1;
    }

    return factorial(number - 1) * number;
}

int calc_fib(int num)
{
    int fib_numbers[num];
    fib_numbers[0] = 0;
    fib_numbers[1] = 1;
    for (int idx = 2; idx <= num; idx++)
    {
        fib_numbers[idx] = fib_numbers[idx - 1] + fib_numbers[idx - 2];
    }

    return fib_numbers[num];
}

int get_digit_sum(int number)
{
    int digit_sum = 0;
    while (number > 0)
    {
        digit_sum += number % 10;
        number /= 10;
    }

    return digit_sum;
}

vector<int> changeless(int number, int lowest_mult, int biggest_mult)
{
    vector<int> my_vector;
    for (int curr_num = 0; curr_num <= number; curr_num++)
    {
        int jdx = lowest_mult;
        while (get_digit_sum(jdx * curr_num) == get_digit_sum(curr_num) and jdx <= biggest_mult)
        {
            jdx++;
        }
        if (jdx == biggest_mult + 1)
            my_vector.push_back(curr_num);
    }
    return my_vector;
}

int sum_of_dividers(int number, int divider)
{
    if (divider < number)
    {
        if ( number % divider == 0 )
            return divider + sum_of_dividers(number, divider + 1);
        else
            return sum_of_dividers(number, divider + 1);
    }
    else return 0;
}

string int_to_string(int num)
{
    ostringstream temp;
    temp << num;
    return temp.str();
}

vector<string> friends(int number)
{
    vector<string> answer;
    for (int idx = 1; idx <= number; idx++)
    {
        for (int jdx = idx + 1; jdx <= number; jdx++)
        {
            if ( sum_of_dividers(idx) == jdx or sum_of_dividers(jdx) == idx )
            {
                string curr_str = int_to_string(idx) + " && " +  int_to_string(jdx);
                answer.push_back(curr_str);
            }
        }
    }

    return answer;
}